Subject: bug#74413: [PATCH] Allow to store and read repository information of VCS builds

From: Eli Zaretskii <[email-masked]>
Date: Tue, 19 Nov 2024 17:16:33 +0200

> From: Björn Bidar <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked]
> Date: Mon, 18 Nov 2024 23:48:38 +0200
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> > I still don't think I understand, sorry.  Do you mean the file is
> > generated from a Git repository, but then Emacs is somehow built from
> > a directory that is not under Git?
> 
> The file can be generated from the git repository outside of the Emacs
> builder.

So you mean someone will chdir to the Git repository, say

  $ make etc-emacsver

Then take the produced file and manually install it when Emacs is
built (in another directory) and installed, is that right?

> > But if this is the scenario, how can you be sure the produced Emacs binary was made from that revision
> > on that branch?  This is only guaranteed if you actually build from
> > Git when you record this information.
> >
> > What am I missing?
> 
> If the source is generated by the CI it can also store this information
> in the build source which then can be extracted from the ci metadata to
> the Emacs sources on the builder.
> 
> I can be sure that Emacs was built from that revision as much as I can
> trust the CI to use the sources I told it to use. If I can't trust one,
> I can't trust the other.

But CI builds from Git, doesn't it?  If so, the Emacs it produces
already records the revision and the branch.